<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Users admin | Dashboard 2</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome Icons -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
</head>
<body class="hold-transition dark-mode sidebar-mini layout-fixed layout-navbar-fixed layout-footer-fixed">
<div class="wrapper">

  <!-- Preloader -->
  <div class="preloader flex-column justify-content-center align-items-center">
    <img class="animation__wobble" src="dist/img/AdminLTELogo.png" alt="AdminLTELogo" height="60" width="60">
  </div>

  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-dark">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="index3.html" class="nav-link">Home</a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Users</a>
      </li>
    </ul>

  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index3.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">AdminLTE 3</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user panel (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
        </div>
        <div class="info">
          <a href="#" class="d-block">Phuonglhm</a>
        </div>
      </div>

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link active">
              <i class="nav-icon fas fa-tachometer-alt"></i>
              <p>
                Dashboard
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="../Task 45.30 CRUD voucher/Task 45.30.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Quản trị Vouchers</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="/45.40.html" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Quản trị Người dùng</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="../Task 45.50 filter orders/Task 45.50.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Quản trị Orders</p>
                </a>
              </li>
            </ul>
          </li>
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0">Quản trị người dùng</h1>
          </div><!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">Users</li>
            </ol>
          </div><!-- /.col -->
        </div><!-- /.row -->
      </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        
        <!--User DataTable -->
    <div class="container">
      <div class="text-center my-4">
          <h2> Danh sách người dùng đăng ký</h2>
      </div>
      <button class="btn btn-success form-group" id="btn-add-user" data-toggle = "modal" data-target="#insert-user-modal">Thêm User</button>
      <table class="table table-bordered table-striped table-hover text-center" id="user-table">
          <thead>
              <tr>
                  <th scope="col">ID</th>
                  <th scope="col">Firstname</th>
                  <th scope="col">Lastname</th>
                  <th scope="col">Country</th>
                  <th scope="col">Subject</th>
                  <th scope="col">CustomerType</th>
                  <th scope="col">Register Status</th>
                  <th scope="col">Action</th>
              </tr>
          </thead>
          <tbody>
          </tbody>
      </table>
  </div>
<!-- Vùng Modal -->

<!-- Create USER modal -->
<div>
  <div id="insert-user-modal" class="modal fade" tabindex="-1">
    <div class="modal-dialog">
      <div class="modal-content">
          <!--modal header-->
        <div class="modal-header">
          <h5 class="modal-title" >Thêm User</h5>
          <button type = "button" class="close" data-dismiss="modal">&times;</button>
        </div>
        <!--modal body-->
        <div class="modal-body">
          <form>
            <div class="row form-group">
              <div class="col-sm-4">
                <label >FirstName</label>
              </div>
              <div class="col-sm-8">
                <input type="text" id="input-firstname"  class="form-control">
              </div>
            </div>
            <div class="row form-group">
              <div class="col-sm-4">
                <label >LastName</label>
              </div>
              <div class="col-sm-8">
                <input type="text" id="input-lastname"   class="form-control">
              </div>
            </div>
            <div class="row form-group">
              <div class="col-sm-4">
                <label >Subject</label>
              </div>
              <div class="col-sm-8">
                <input type="text" id="input-subject"   class="form-control">
              </div>
            </div>
            <div class="row form-group">
              <div class="col-sm-4">
                <label >Country</label>
              </div>
              <div class="col-sm-8">
                  <select id="select-country"   class="form-control">
                      <option value="NOT_SELECT_COUNTRY"> Select Country</option>
                      <option value="VN"> Việt Nam</option>
                      <option value="USA"> USA </option>
                      <option value="AUS"> Australia </option>
                      <option value="CAN"> Canada </option>
                  </select>
              </div>
            </div>
          </form>
        </div>
        <!--modal footer-->
        <div class="modal-footer">
          <button class="btn btn-success" id="btn-create-user" >Insert User</button>
          <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
        </div>
      </div>
  </div>
</div>

<!-- Update USER modal -->
<div>
  <div id="update-user-modal" class="modal fade" tabindex="-1">
    <div class="modal-dialog">
      <div class="modal-content">
          <!--modal header-->
        <div class="modal-header">
          <h5 class="modal-title" >Update User</h5>
          <button type = "button" class="close" data-dismiss="modal">&times;</button>
        </div>
        <!--modal body-->
        <div class="modal-body">
          <form>
            <div class="row form-group">
              <div class="col-sm-4">
                <label >FirstName</label>
              </div>
              <div class="col-sm-8">
                <input type="text" id="input-update-firstname"  class="form-control">
              </div>
            </div>
            <div class="row form-group">
              <div class="col-sm-4">
                <label >LastName</label>
              </div>
              <div class="col-sm-8">
                <input type="text" id="input-update-lastname"   class="form-control">
              </div>
            </div>
            <div class="row form-group">
              <div class="col-sm-4">
                <label >Subject</label>
              </div>
              <div class="col-sm-8">
                <input type="text" id="input-update-subject"   class="form-control">
              </div>
            </div>
            <div class="row form-group">
              <div class="col-sm-4">
                <label for="select-update-country" >Country</label>
              </div>
              <div class="col-sm-8">
                  <select id="select-update-country" name="country"  class="form-control">
                      <option value=""> Select Country</option>
                      <option value="VN"> Việt Nam</option>
                      <option value="USA"> USA </option>
                      <option value="AUS"> Australia </option>
                      <option value="CAN"> Canada </option>
                  </select>
              </div>
            </div>
            <div class="row form-group">
              <div class="col-sm-4">
                <label for="select-update-customer-type" >Customer Type</label>
              </div>
              <div class="col-sm-8">
                  <select id="select-update-customerType" name="customerType"  class="form-control">
                      <option value="Standard"> Standard </option>
                      <option value="Gold"> Gold </option>
                      <option value="Premium"> Premium </option>
                  </select>
              </div>
            </div>
            <div class="row form-group">
              <div class="col-sm-4">
                <label for="select-update-register-status" >Register Status</label>
              </div>
              <div class="col-sm-8">
                  <select id="select-update-registerStatus" name="registerStatus"  class="form-control">
                      <option value="0"> Select Register Status</option>
                      <option value="Accepted"> Accepted</option>
                      <option value="Denied"> Denied </option>
                      <option value="Standard"> Standard </option>
                  </select>
              </div>
            </div>
          </form>
        </div>
        <!--modal footer-->
        <div class="modal-footer">
          <button class="btn btn-success" id="btn-update-user" >Update User</button>
          <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
        </div>
      </div>
  </div>
</div>

<!-- Delete confirm modal -->
<div>
<div class="modal fade" tabindex="-1" id="delete-confirm-modal">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="h5-modal-title">User Delete Confirmation</h5>
        <button class="close" data-dismiss="modal">&times;</button>
      </div>
      <div class="modal-body">
        <label>Bạn có chắc chắn muốn xóa User này không?</label>
      </div>
      <div class="modal-footer">
        <button class="btn btn-danger" id="btn-confirm-delete-user">Confirm</button>
        <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
      </div>
    </div>
  </div>
</div>
</div>
<!--Vùng modal-->

      </div><!--/. container-fluid -->
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->

  <!-- Control Sidebar -->
  <aside class="control-sidebar control-sidebar-dark">
    <!-- Control sidebar content goes here -->
  </aside>
  <!-- /.control-sidebar -->

  <!-- Main Footer -->
  <footer class="main-footer">
    <strong>Copyright &copy; 2014-2021 <a href="45.40.html">Devcamp120</a>.</strong>
    All rights reserved.
    <div class="float-right d-none d-sm-inline-block">
      <b>Version</b> 3.2.0
    </div>
  </footer>
</div>
<!-- ./wrapper -->

<!-- REQUIRED SCRIPTS -->
<!-- jQuery -->
<script src="plugins/jquery/jquery.min.js"></script>
<!-- Bootstrap -->
<script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
<!-- AdminLTE App -->
<script src="dist/js/adminlte.js"></script>

<!-- AdminLTE for demo purposes -->
<script src="dist/js/demo.js"></script>

<script>
  $(document).ready(function() {
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  var gCountryObjects = [
      {
          value: "VN",
          text: "Việt Nam"
      },
      {
          value: "USA",
          text: "Mỹ"
      },
      {
          value: "AUS",
          text: "Úc"
      },
      {
          value: "CAN",
          text: "Canada"
      }
  ];
  //Biến mảng hằng số chứa danh sách các thuộc tính
  const gUSER_COLUMN = [
      "id",
      "firstname",
      "lastname",
      "country",
      "subject",
      "customerType",
      "registerStatus",
      "action"
  ];
  //Hằng số định nghĩa chỉ số các cột tương ứng trong datatable
  const gUSER_ID = 0;
  const gFIRST_NAME = 1;
  const gLAST_NAME = 2;
  const gCOUNTRY = 3;
  const gSUBJECT = 4;
  const gCUSTOMER_TYPE = 5;
  const gREGISTER_STATUS = 6;
  const gACTION = 7;

  //Đổ dữ liệu vào bảng và thực hiện nút Sửa (edit), xóa(delete)
  $("#user-table").DataTable({
      columns: [
        {data:gUSER_COLUMN[gUSER_ID]},
        {data:gUSER_COLUMN[gFIRST_NAME]},
        {data:gUSER_COLUMN[gLAST_NAME]},
        {data:gUSER_COLUMN[gCOUNTRY]},
        {data:gUSER_COLUMN[gSUBJECT]},
        {data:gUSER_COLUMN[gCUSTOMER_TYPE]},
        {data:gUSER_COLUMN[gREGISTER_STATUS]},
        {data:gUSER_COLUMN[gACTION]},
    ],
    columnDefs: [ 
      {
          targets: gCOUNTRY, // định nghĩa lại cột Country
          render: function(data) {
              return getCountryTextByCountryValue(data)
          }
      },
      {
          targets: gACTION, // định nghĩa lại cột ACTION
          className: "text-center",
          defaultContent: `
          <button class = "btn btn-primary btn-edit"> Sửa </button>
          <button class = "btn btn-danger btn-delete" data-toggle = "modal"> Xóa </button>
          `
      }
      ],
      autoWidth: false
  });

  //biến mảng chứa dữ liệu users
  var gListUsers = [];
  const gNOT_SELECT_COUNTRY = "NOT_SELECT_COUNTRY"; //giá trị value khi chưa chọn country
  var gUser_CRUD = 0 // Biến toàn cục để lưu trữ id user đang đc update or delete. Mặc định = 0;

  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  onPageLoading();
  //2 - C: gán sự kiện Create - thêm mới user
  $("#btn-add-user").on("click", function() {
      onBtnAddNewUserClick();
  });
  $("#btn-create-user").click(function(){
      onBtnInsertUserClick();
  })

  //3 - U: gán sự kiện Update - sửa 1 user 
  $(document).on("click", "#user-table .btn-edit", function(){ //Với từng Nút, trong nhóm class.btn-detail đều gán function Xử lý sự kiện click
      onBtnEditClick(this); })
  $("#btn-update-user").click(function(){
      onBtnUpdateUserClick()
  })
  //4 - D: gán sự kiện Delete - xóa 1 user 
  $(document).on("click", "#user-table .btn-delete", function(){ //Với từng Nút, trong nhóm class.btn-detail đều gán function Xử lý sự kiện click
      onBtnDeleteClick(this); })
  $("#btn-confirm-delete-user").click(function(){
    onBtnConfirmDeleteUserClick()
  })
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  function onPageLoading() {
      "use strict";
      getAllUsers()
  }

  function onBtnAddNewUserClick() {
      //hiển thị modal trắng lên
      $("#insert-user-modal").modal("show")
  }

  //hàm xử lý sự kiện click nút insert user
  function onBtnInsertUserClick() {
      "use strict"
      //khai báo đối tượng chứa user data
      var vUserObj = {
          firstname: "",
          lastname: "",
          subject: "",
          country: ""
      }
      //B1: thu thập dữ liệu
      getUserDataInsert(vUserObj);
      //B2: validate insert data
      if(validateInsertData(vUserObj)) {
          //B3: insert user
          postUserAPI(vUserObj);
          //B4: xử lý front-end
          //gọi API lấy danh sách user
          getAllUsers();
          //load lại vào bảng(table)
          loadDataToTable(gListUsers);
          //xóa trắng dữ liệu trên modal
          resetInsertUserForm();
          //Ẩn modal form create user
          $("#insert-user-modal").modal("hide")
      }
  }

  //function xử lý sự kiện click nút sửa
  function onBtnEditClick(paramBtnElement){
        "use strict";
        console.log("Btn Edit Click!!!");
        //lưu thông tin id của user đang được edit vào biến toàn cục
        gUser_CRUD = getUserIDFromBtn(paramBtnElement)
        console.log("ID user được update: " + gUser_CRUD);
        //debugger;
        //load dữ liệu vào các trường dữ liệu trong modal
        showDataToModal(gUser_CRUD);
         //hiển thị modal lên
         $("#update-user-modal").modal("show");
      }
  //hàm xử lý sự kiện click nút update user
  function onBtnUpdateUserClick(){
      "use strict";
          // B0: Tạo đối tượng lưu trữ dữ liệu user
          var vUserObj = {
              firstname: "",
              lastname: "",
              subject: "",
              country: "",
              customerType: "",
              registerStatus: ""
          };
          // B1: Thu thập dữ liệu từ input modal
          getDataFromModalUpdateUserInput(vUserObj);
          console.log(vUserObj);
          // B2: Validate dữ liệu
          var vIsCheckUser = validateUpdateUser(vUserObj);
          console.log(vIsCheckUser);
          // Bước 3: Call api khi dữ liệu hợp lệ
          if (vIsCheckUser == true) {
              callApiPutUser(vUserObj);
              getAllUsers();
              resetUpdateUserForm();
              $("#update-user-modal").modal("hide");
          }
  }
      //function xử lý sự kiện click nút xóa
  function onBtnDeleteClick(paramBtnElement){
        "use strict";
        console.log("Btn Delete Click!!!");
        //lưu thông tin id của user đang được delete vào biến toàn cục
        gUser_CRUD = getUserIDFromBtn(paramBtnElement)
        console.log("User ID cần Delete: " + gUser_CRUD);
        $("#delete-confirm-modal").modal("show")
      }
      // hàm xử lý sự kiện confirm delete user modal click
  function onBtnConfirmDeleteUserClick() {
    //khai báo đối tượng chưa voucher data (bỏ qua)
    //B1: Thu thập dữ liệu (bỏ qua)
    //B2: Validate delete data (bỏ qua)
    //B3: Delete voucher
    deleteUser(gUser_CRUD);
    //B4; xử lý front-end
    alert("Xóa User thành công!");
    loadDataToTable(gListUsers);
    $("#delete-confirm-modal").modal("hide");
  }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  //hàm get all users
  function getAllUsers() {
      $.ajax({
          url: "http://42.115.221.44:8080/crud-api/users/",
          type: "GET",
          dataType: 'JSON',
          success: function(paramObject) {
              //debugger; //dùng debugger để kiểm tra xem response định dạng là gì, có phải mảng dữ liệu  chúng ta sẽ sử dụng không?
              gListUsers = paramObject;
              loadDataToTable(gListUsers);
          },
          error: function (ajaxContext) {
              alert(ajaxContext.responseText)
          }
      });
  }
  //hàm lấy text country theo value country
  function getCountryTextByCountryValue(paramCountry) {
      "use strict"
      var vTextCountry = "";
      for (var bI = 0; bI < gCountryObjects.length;bI++) {
          if(gCountryObjects[bI].value == paramCountry) {
              vTextCountry = gCountryObjects[bI].text
          }
      }
      return vTextCountry;
  }

  //hàm load dữ liệu vào table
  function loadDataToTable(paramObjUsers) {
      "use strict"
      console.log(paramObjUsers);
      var vTable = $("#user-table").DataTable();
      vTable.clear();
      vTable.rows.add(paramObjUsers);
      vTable.draw();
  }

  
  //hàm lấy ID user nơi button update/delete được click
  function getUserIDFromBtn(paramBtnElement){
      var vRowClick = $(paramBtnElement).closest("tr"); //xác định parent tr chứa nút bấm được click
        var vTable = $("#user-table").DataTable(); //tạo biến truy xuất đến datatable
        var vDataRow = vTable.row(vRowClick).data(); //lấy dữ liệu của hàng dữ liệu chứa nút bấm được click
        return vDataRow.id
  }
  
  //load data user cần sửa lên modal
  function showDataToModal(paramUserId) {
      var vUserIndex = getIndexFromUserId(paramUserId);
      console.log(vUserIndex);
      $("#input-update-firstname").val(gListUsers[vUserIndex].firstname);
      $("#input-update-lastname").val(gListUsers[vUserIndex].lastname);
      $("#input-update-subject").val(gListUsers[vUserIndex].subject);
      $("#select-update-country").val(gListUsers[vUserIndex].country);
      $("#select-update-customerType").val(gListUsers[vUserIndex].customerType);
      $("#select-update-registerStatus").val(gListUsers[vUserIndex].registerStatus);

  }

  ///* get voucher index from voucher id
  // input: paramVoucherId là voucherId cần tìm index
  // output: trả về chỉ số (index) trong mảng voucher */
  function getIndexFromUserId(paramUserId) {
      var vUserIndex = -1;
      var vUserFound = false;
      var vLoopIndex = 0;
      while(!vUserFound && vLoopIndex < gListUsers.length) {
      if(gListUsers[vLoopIndex].id === paramUserId) {
          vUserIndex = vLoopIndex;
          vUserFound = true;
      }
      else {
          vLoopIndex ++;
      }
      }
      return vUserIndex;
  }
  //hàm thu thập dữ liệu để insert user
  function getUserDataInsert(paramUserObj) {
      "use strict";
      paramUserObj.firstname = $("#input-firstname").val().trim();
      paramUserObj.lastname = $("#input-lastname").val().trim();
      paramUserObj.subject = $("#input-subject").val().trim();
      paramUserObj.country = $("#select-country").val();
  }
  //hàm validate data khi insert
  function validateInsertData(paramUserObj) {
      "use strict"
      if(paramUserObj.firstname == "") {
          alert("Firstname cần nhập");
          return false;
      };
      if(paramUserObj.lastname == "") {
          alert("Lastname cần nhập");
          return false;
      };
      if(paramUserObj.subject == "") {
          alert("Subject cần nhập");
          return false;
      };
      if(paramUserObj.country == gNOT_SELECT_COUNTRY) {
          alert("Country cần chọn");
          return false;
      };
      return true;
  }

  //hàm gọi api để insert user
  function postUserAPI(paramUserObj) {
      "use strict"
      $.ajax({
          async:false,
          url: "http://42.115.221.44:8080/crud-api/users/",
          type:"POST",
          data: JSON.stringify(paramUserObj),
          contentType:"application/json;charset=UTF-8",
          success: function(res) {
              console.log(res);
              alert("Thêm user thành công!")
          },
          error: function(error) {
              alert(error.responseText);
          }
      });
  }

  //hàm xóa trắng form insert user
  function resetInsertUserForm() {
      $("#input-firstname").val("");
      $("#input-lastname").val("");
      $("#input-subject").val("");
      $("#select-country").val(gNOT_SELECT_COUNTRY);
  }

  // Hàm thu thập dữ liệu từ input trong modal update user
  function getDataFromModalUpdateUserInput(paramUserObj) {
          "use strict";
          paramUserObj.firstname = $.trim($('#input-update-firstname').val());
          paramUserObj.lastname = $.trim($('#input-update-lastname').val());
          paramUserObj.subject = $.trim($('#input-update-subject').val());
          paramUserObj.country = $('#select-update-country').val();
          paramUserObj.customerType = $('#select-update-customerType').val();
          paramUserObj.registerStatus = $('#select-update-registerStatus').val();
      }
  
      // Hàm validate trong modal update user
      function validateUpdateUser(paramUserObj) {
          "use strict";
          if (paramUserObj.firstname === "") {
              alert("Chưa nhập firstname!");
              return false;
          }
          if (paramUserObj.lastname === "") {
              alert("Chưa nhập lastname!");
              return false;
          }
          if (paramUserObj.subject === "") {
              alert("Chưa nhập subject!");
              return false;
          }
          if (paramUserObj.country == "") {
              alert("Chưa nhập Country!");
              return false;
          }
          if (paramUserObj.registerStatus == 0) {
              alert("Chưa nhập RegisterStatus!");
              return false;
          }
          return true;
      }

      // Hàm call api put new user
      function callApiPutUser(paramUserObj) {
          "use strict";
          $.ajax({
              url: "http://42.115.221.44:8080/crud-api/users/" + gUser_CRUD,
              type: 'PUT',
              data: JSON.stringify(paramUserObj),
              dataType: 'json',
              contentType: "application/json;charset=UTF-8",
              async: false,
              success: function(result) {
                  alert("Update thành công user: " + Object.entries(result));
              },
              error: function(error) {
                  console.log(error.responseText);
              }
          });
      }

      // Hàm xóa trắng modal update user
      function resetUpdateUserForm() {
          "use strict";
          $("#input-update-firstname").val("");
          $("#input-update-lastname").val("");
          $("#input-update-subject").val("");
          $("#select-update-country").val("0");
          $("#select-update-customerType").val("");
          $("#select-update-registerStatus").val("");
      }

      // hàm xóa user theo id user
function deleteUser(paramUserId) {
  var vUserIndex = getIndexFromUserId(paramUserId);
  gListUsers.splice(vUserIndex, 1);
}
});
</script>
</body>
</html>
